import React, {forwardRef, useCallback, useRef, useState, useEffect, useMemo} from 'react'
import RcCheckbox from '../rc-checkbox'
import Group from './group'
import { Consumer } from './groupContext'


class Checkbox extends React.PureComponent{
  constructor(props) {
    super(props)
    this.state = {
      checked: props.checked || false
    }
  }
  checkboxChange = (e) => {
    this.setState({checked: e.target.checked}, () => {
      this.props.onChange&&this.props.onChange(e)
      this.group&&this.group.onChange(e)
    })
  }
  componentDidMount () {
    this.group && this.group.fields.push(this)
  }
  render () {
    let { children, style, ...restProps } = this.props

    return <Consumer>
      {
        (context) => {
          this.group = context
          return <label className='checkbox' style={style}>
            <RcCheckbox {...restProps} onChange={this.checkboxChange}/>
            <span>{children}</span>
          </label>
        }
      }
    </Consumer>
  }
}

// const Checkbox = forwardRef((props,  ref) => {
//   let { className, children, style, skipGroup = false, onChange, ...restProps } = props
//   let group
//   let __this = useMemo(() => ({}), [])
  
//   useEffect(() => {
//     group&&group.fields.push(Math.random())
//   }, [])

//   const checkboxChange = useCallback((e) => {
//     onChange&&onChange(e)
//     group&&group.toggleOption()
//   }, [])

//   return <Consumer>
//     {
//       (context) => {
//         group = context
//         return <div className='checkbox'>
//           <RcCheckbox {...props} onChange={checkboxChange}/>
//           {children}
//         </div>
//       }
//     }
//   </Consumer>
// })

// Checkbox.displayName = 'Checkbox'
Checkbox.Group = Group

export default Checkbox