import React from 'react'
import Dialog from './dialog'
import ReactDOM from 'react-dom'

export const $dialog = (props = {}) => {
  let { portalTarget, ...other } = props
  let container = portalTarget || document.querySelector('#portal-target')
  let dialogRef = React.createRef()
  if (!container) {
    container = document.createElement('div')
    container.id = 'portal-target'
    document.body.appendChild(container)
  }
  other.portalTarget = container
  other.fromInstance = true
  other.visible = true
  ReactDOM.render(<Dialog ref={dialogRef} {...other} />, container)
  return dialogRef.current
}

export const $tip = (props = {}) => {
  props.showCancelBtn = false
  if (!props.confirmBtnText) props.confirmBtnText = '我知道了'
  if (!props.onConfirm) props.onConfirm = function () { this.remove() }
  $dialog(props)
}

export default Dialog