import { $dialog } from '../dialog'
import { classNames } from '../../utils/assist'
import LoadingCircle from '../icons/loading-circle'
import './style/loading.less'

const prefixCls = 'r-loading'

let globalConfig = {}

const $loading = (options = {}) => {
  const { icon, text, textStyle } = options
  options = Object.assign({
    message: <>
      {icon || globalConfig.icon || <LoadingCircle />}
      {(text || globalConfig.text) && <div className='loading-text' style={textStyle}>
        {text || globalConfig.text}
      </div>}
    </>,
    showCancelBtn: false,
    showConfirmBtn: false,
    fromInstance: true
  }, options)

  options.className = classNames([prefixCls, options.className])

  let loading = $dialog(options)
  return loading
}

$loading.config = (options = {}) => {
  globalConfig = options
}

export default $loading