import React, { memo } from 'react'
import PropTypes from 'prop-types'
import './style/titlebar.less'

const prefixCls = 'r-titlebar'

const Titlebar = memo(({ theme, l, c, r, children, showBackto, backArrowStyle, onBack, className }) => {
  const wrapCls = [prefixCls, `${prefixCls}-theme-${theme}`, className].filter(Boolean).join(' ')
  const arrowStyle = backArrowStyle ? backArrowStyle : { color: /^(b|c|d|e|f)$/.test(theme) ? '#fff' : '#333' }

  console.log('Titlebar mounted or updated')
  
  return (
    <div className={wrapCls}>
      {showBackto && <div className='l-operate' onClick={(e) => onBack && onBack(e)}>
        {l ? l : <div className="back"><svg width="10px"
          height="21px"
          style={arrowStyle}
          viewBox="0 0 10 21"
          version="1.1"
          xmlns="http://www.w3.org/2000/svg"
          xmlnsXlink="http://www.w3.org/1999/xlink">
          <g stroke="none"
            strokeWidth="1"
            fill="none"
            fillRule="evenodd"
            strokeLinecap="round">
            <g transform="translate(-16.000000, -33.000000)"
              stroke={arrowStyle.color}
            >
              <polyline id="Path-2"
                points="25.758131 34 16 43.3837058 26 53"></polyline>
            </g>
          </g>
        </svg></div>}
      </div>}
      {c || children}
      <div className='r-operate'>{r}</div>
    </div>
  )
})
Titlebar.defaultProps = {
  theme: 'a',
  showBackto: true
}
Titlebar.propTypes = {
  theme: PropTypes.string,
  showBackto: PropTypes.bool,
  backArrowStyle: PropTypes.object
}

export default Titlebar